# DCCS User Guide


## DCCS 功能說明
讓終端透過 Key 來取得 Credential，然後使用 credential 來存取服務。 

![](../uploads/images/DCCS/overview.png)

功能詳細說明：
1. 終端嘗試連線服務時，發現因缺乏憑證或是憑證有誤，導致無法使用服務。
2. 終端透過金鑰向 DCCS 查找憑證。
3. DCCS 在資料庫找到與金鑰相符的憑證。
4. DCCS 返回憑證給終端。
5. 終端使用正確的憑證成功連線服務。

## DCCS 使用程序

- 登入網站 technical portal。注意，使用者必須有使用 management console 的權限。

![](../uploads/images/DCCS/tp.png)

- 在 technical portal 上方選單裡點選 "My Space" ---> "Management Console"，進入 management console。

![](../uploads/images/DCCS/tp-to-mp.png)

- 在 management console 左方的選單點選某個 space，然後點選 "Service Instance List"，在畫面右邊可以看到目前已經存在的 service instance。
在畫面左邊可以看到服務清單，在這裡要確認所要的服務名稱，在後續向 DCCS 請求資料時會用到服務名稱。

![](../uploads/images/DCCS/service-instance.png)

- 選擇某一筆 service instance 來進行操作，點選 "Credentials" 欄位中的 "View"，下方會彈出目前的 credentials 清單。

![](../uploads/images/DCCS/key.png)

- 在 credential 清單中，選擇某一筆 credential 資料，在 "username" 這個欄位中可以看到內容值為一個長字串，這個字串就是金鑰，可用於 DCCS 資料查找。

- 使用者的設備端機器，可以使用上述的軟體名稱與金鑰為索引，呼叫 DCCS 的 REST API 來取得連線資料。

DCCS REST API
```
GET     {DCCS網址}/v1/serviceTypes/{服務名稱}/credential/{金鑰}
``` 
- 從 DCCS 返回的 Json 格式資料，使用者可取得服務的網址與憑證。

![](../uploads/images/DCCS/credential.png)