Management Console Tenant Admin Guide
==========


登入界面
-----

進入Technical Portal URL。

* 點擊"Sign In"，會進入登入畫面。
* 輸入帳號密碼登入後，點擊右上角"My Space"進入Management Console管理界面。

![](../uploads/images/ManagementPortal/admin/01_login.png)

操作界面
-----

![](../uploads/images/ManagementPortal/admin/02_screen_tenant.png)

* A-1 : 功能選單。
* A-2：功能操作頁面。
* A-3：分別為語言與登出功能。
* 操作Management Console功能時，右下角會顯示操作功能的結果說明。
* 過程正常顯示綠色：

![](../uploads/images/ManagementPortal/admin/03_success.png)

* 過程有誤顯示紅色：

![](../uploads/images/ManagementPortal/admin/04_error.png)
軟體需求
------

* 建議瀏覽視窗解析度：1024x768或以上。
* 建議瀏覽器(版本以最新為主)：
  * Google Chrome
  * Microsoft Edge
  * IE 11 (Windows 10)
  * Safari

Organization 管理
-------
可於此頁面觀看系統中Organizations，僅提供更名。

![](../uploads/images/ManagementPortal/admin/05_orglist_tenant.png)

![](../uploads/images/ManagementPortal/admin/07_rename_org.png): 更名Organization，名稱長度為16字元。

**註：上述動作有名稱限制。**

![](../uploads/images/ManagementPortal/admin/08_orgNameLimit.png)


Space 管理
-------

於此頁面可針對特定Organization進行Space空間管理。左邊為該Organization的Space列表，並可監控Organization的資源使用量。

![](../uploads/images/ManagementPortal/admin/10_spacelist.png)

*  Space List: 可新增、刪除與更名Space。
   ![](../uploads/images/ManagementPortal/admin/add_space.png)
   * Total Space Memory: Space可用Memory上限。
   * Total Service Instance: Space可允許服務實例上限。
   * Total Application Instance: Space可允許應用程式實例上限。
   * Instance Memory: 應用程式實例Memory上限。
   * Total Routes: Space可允許路由個數上限。

*  Space Quota: 可於此分頁進行新增、刪除與設定Quota，並可套用指定Quota到特定Space。
   ![](../uploads/images/ManagementPortal/admin/11_spacequota.png)
   * 套用Space Quota: 點擊指定Space Quota，會顯示目前套用此Quota的Space。
     再點擊欲套用的Space，若該Space尚未套用任何Quota，會立即套用，反之會跳出詢問視窗，提示該Space目前已有Ouota，若再套用將會覆蓋最新的。
   ![](../uploads/images/ManagementPortal/admin/54_applyQuota.png)
   * Create: 可新增Quota template。名稱長度為16字元，各欄位皆有輸入限制
   ![](../uploads/images/ManagementPortal/admin/12_createquota.png)
   * Unit: 以MB/GB/TB單位進行檢視。
   * Quota Name: Quota名稱。
   * Space Memory Limit: Space Memory上限。
   * Service Instance Limit: 服務實例個數上限。
   * Application Instance Limit: 應用程式實例個數上限。
   * Instance Memory Limit: 應用程式實例Memory上限。
   * Routes Limit: 應用程式路由個數上限。
   * Operation: 調整各項資源數值與刪除Quota功能。

*  Usage:  顯示該Organization所使用的各項資源總用量資訊與細節。
    點選各資源的量測項目(Metric)欄位的(+)可以展開看到該Organization下，每一個Space所使用的用量細節；(-)縮合。
   ![](../uploads/images/Metering/ManagementPortalUsage/15_usage_org01.JPG)
   * 下拉式時間選單: 可以選擇不同時間區間觀看用量。
   ![](../uploads/images/Metering/ManagementPortalUsage/15_usage_org02.JPG)
   * 各項資源選單: 初始為顯示該Organization所有使用的資源訊息，可以勾選顯示/取消顯示資源訊息於畫面上。
   ![](../uploads/images/Metering/ManagementPortalUsage/15_usage_org03.JPG)
   * space選單: 初始為顯示該Organization下所有的space，可以勾選顯示/取消顯示space 清單。
   ![](../uploads/images/Metering/ManagementPortalUsage/15_usage_org04.JPG)
   * 具中英語言頁面。
   ![](../uploads/images/Metering/ManagementPortalUsage/15_usage_org05.JPG)

Space 功能操作說明
-------
此章節說明Space開發者主要操作功能。

* Application List: 此分頁用於管理已上傳的應用程式。
  ![](../uploads/images/ManagementPortal/admin/17_orgmonitor.png)
   * 應用程式管理: 顯示已部署的應用程式列表。
      * State：開啟/關閉應用程式，搭配Package State能更加瞭解應用程式目前狀況。
         * ![](../uploads/images/ManagementPortal/admin/19_open.png): 開啟中，對應的Package State為Staged，可直接點擊將該應用程式進行關閉。
         * ![](../uploads/images/ManagementPortal/admin/20_close.png): 關閉中，對應的Package State為Staged，可直接點即將該應用程式進行開啟。
         **註：以上兩個皆為正常操作狀態，因此Package State皆表示正常上架(Staged)。**
         * ![](../uploads/images/ManagementPortal/admin/21_stage.png): 應用程式上架中，對應的Package State為Pending，上架完成會變成State ON。
         * ![](../uploads/images/ManagementPortal/admin/22_fail.png): 應用程式異常，對應的Package State為Failed，應用程式無法啟動，開發者須進行除錯。
      * Name：應用程式名稱。
      * Instances：應用程式實例總數。
      * Running Status：應用程式實例狀態。
      * CPU：應用程式實例CPU使用量。
      * Memory：應用程式可使用的記憶體空間上限。
      * Disk：應用程式可使用的磁碟空間上限。
      * 點擊個別應用程式會出現Routes、Instance Status(2個以上)、Environment Variables以及Log，並且可進行Scale與Delete
      ![](../uploads/images/ManagementPortal/admin/24_app.png)
         * Instance Status會顯示應用程式實例的使用狀況。
         * Routes顯示綁定該應用程式的所有路由。
         * Environment Variables會顯示應用程式的環境變數與綁定服務的存取權限。
         * Log會顯示該應用程式最新的操作紀錄。
         * 擴增/縮減應用程式資源: 點擊鉛筆符號可調整應用程式數值。
         ![](../uploads/images/ManagementPortal/admin/35_scaleapp.png)
           * Memory Size：應用程式可使用的記憶體空間上限。
           * Disk Size：應用程式可使用的磁碟空間上限。
           * Instance : 應用程式實例數量。
           * 上述欄位輸入完成後點擊下方Scale按鈕開始擴增/刪減應用程式資源。
           
           **註：若設定的資源超過此Space的上限，此擴增的動作將會失敗。**
           ![](../uploads/images/ManagementPortal/admin/37_scalerr.png)
         * 刪除應用程式: 點擊刪除鍵可刪除應用程式，會跳出詢問視窗。
         ![](../uploads/images/ManagementPortal/admin/23_ask.png)


* Service Instance List: 此頁面顯示可訂閱的服務列表，以及存在於此Space的服務實例。
  * Service List：點擊+號會顯示可訂閱服務列表，選擇後按OK會於最下方設定建立Service Instance Name，完成後按勾立即建立。
  **註：建立Instancec後亦會預設建立一把金鑰**
    ![](../uploads/images/ManagementPortal/admin/38_serviceIns.png)
    ![](../uploads/images/ManagementPortal/admin/39_createIns.png)
  * Service Instance List：已存在的服務實例。
    * Name：實例名稱。名稱長度為16字元，有輸入限制。
    ![](../uploads/images/ManagementPortal/admin/08_orgNameLimit.png)
    * Service：來源服務。
    * Plan：顯示此來源服務所選Plan。
    * 點擊特定Service Instance後可按刪除鍵進行刪除。
    
    **註：欲刪除成功需先刪除該Instance的所有金鑰**
    * 點擊個別Service Instance可查看該Space下可綁定的應用程式以及已屬於該Instance的服務金鑰，並有管理(建立/刪除)多把金鑰的功能。
    ![](../uploads/images/ManagementPortal/admin/40_createkey.png)
      選擇特定應用程式點選後會立即綁取，欲取消綁定再點擊一次即可。
      ![](../uploads/images/ManagementPortal/admin/BindAPP.png)
      點擊Create可建立新的金鑰。長度16字元，有輸入限制。
      ![](../uploads/images/ManagementPortal/admin/08_orgNameLimit.png)
      點擊刪除鍵會跳出詢問視窗，若確定即立即刪除該金鑰。


Users
---------

SRPs
---------
