Linkou Field Data Quick Guide
=============
|  Fields                             |  
| ------------------------------------|
| 智慧大樓 (Intelligent Building)     | 
| 溫室綠能屋 (Greenhouse)             | 
| 美食街 (Food Court)                 |
| 智能工廠 (Smart Factory)            |

1. 智慧感測場域資料介紹
------------

研華林口智慧園區 

<img src="../uploads/images/SCADAFieldData/Fig1.png" width="600">  


WISE-PaaS 場域資料 

<img src="../uploads/images/SCADAFieldData/Fig2.png" width="600">  

2. 智慧大樓 (Intelligent Building) 
------------

林口一期 1F  
<img src="../uploads/images/SCADAFieldData/Fig3.png" width="600">  

林口一期1F場域資料列表   
<img src="../uploads/images/SCADAFieldData/Fig4.png" width="600">  

林口一期 2F  
<img src="../uploads/images/SCADAFieldData/Fig5.png" width="600">  

林口一期2F場域資料列表 
<img src="../uploads/images/SCADAFieldData/Fig6.png" width="600">  

林口一期 B3  
<img src="../uploads/images/SCADAFieldData/Fig7.png" width="600">  

林口一期 B3場域資料列表   
<img src="../uploads/images/SCADAFieldData/Fig8.png" width="600">  


3. 溫室綠能屋 (Greenhouse)   
--------------

林口一期 戶外三角形屋  
<img src="../uploads/images/SCADAFieldData/Fig9.png" width="600">  

林口一期戶外三角形屋場域資料列表  
<img src="../uploads/images/SCADAFieldData/Fig10.png" width="600">  


4. 美食街 (Food Court) 
--------------

林口二期 1F餐廳  
<img src="../uploads/images/SCADAFieldData/Fig11.png" width="600">  

林口二期1F餐廳場域資料料列表   

| Number             | Description        |
| -------------------|:------------------:|
|          1         |點餐智能化展示區    |
|          2         |座位區              |
|          3         |美食攤位            |
|          4         |自助餐攤位          |
|          5         |自助餐攤位備餐區    |
|          6         |自助餐攤位餐具檯    |
|          7         |美食攤位後場        |
|          8         |回收區/洗手台       |
|          9         |咖啡簡餐餐廳點餐區  |
|          10        |咖啡簡餐座位        |
|          11        |咖啡簡餐活動座椅區  |
|          12        |咖啡簡餐後場工作區  |
|          13        |低矮綠化隔牆        |
|          14        |走廊隔牆            |
|          15        | 工業區4.0展示      |



<img src="../uploads/images/SCADAFieldData/Fig12.png" width="600">   



5. 智能工廠 (Smart Factory)   
--------------

林口二期 5F、6F 板卡製程  
<img src="../uploads/images/SCADAFieldData/Fig13.png" width="600">  

【能源耗電】

| Location           | Category      | Data       |
| -------------------|:-------------:|-----------:|
| SMT Line1          |               |ATML_BESA   |
| SMT Line2          |               |ATML_BESA   |
| SMT Line3          |               |ATML_BESA   |
| SMT Line4          |               |ATML_BESA   |
| SMT Line5          |               |ATML_BESA   |
| SMT Line6          |               |ATML_BESA   |
| SMT Line5迴焊爐    | 能源耗電      |ATML_BERF5  |
| DIP Line1+Line2    |               |ATML_BEDA   |
| DIP Line2+Line4    |               |ATML_BEDB   |
| DIP Line2波峰焊爐  |               |ATML_BEDA   |
| DIP Line4波峰焊爐  |               |ATML_BEDB1  |
| 空壓設備盤         |               |ATML_PACPRF |
| 板卡燒機室         |               |ATML_BEBIR  |
| 系統燒機室         |               |ATML_SEBIA  |
| 低溫烤箱           |               |ATML_BESG   |
| 空壓設備盤         |               |ATML_PACPRF |
| 板卡燒機室         |               |ATML_BEBIR  |

【設備監控】

| Location           | Category      | Data              |
| -------------------|:-------------:|------------------:|
| 波焊爐             |溫度監控       |5FWaveSolder:AI_0  |
|                    |               |5F_N2:concn        |
|                    |               |5F_N2:flow         |
| 氮氣機             |設備監控       |5F_N2:pressure     |
|                    |               |5F_N2:running      |
|                    |               |INCS:AutoSet       |
|                    |               |INCS:IdleSet       |
|                    |               |INCS:N2flow        |
| L3迴焊爐氮氣監控   |氮氣節能控制   |INCS:N2Valve       |
|                    |               |INCS:O2_ppm        |
|                    |               |INCS:SysMode       |
| 錫膏冰箱           |溫度監控       |INCS:TimeIdle      |
|                    |               |L1_Fridge:AI_0     |
|                    |               |B2_AirComp:AI_3    |
| 空壓機             |設備監控       |B2_AirComp:AI_4    |
|                    |               |B2_AirComp:AI_5    |
|                    |               |B2_AirComp:AI_6    |

【影像監控】

| Location           | Category      | Data              |
| -------------------|:-------------:|------------------:|
| SMT                |               |Enterprise_info    |
| DIP                |IP Camera      |VCM_info           |
|                    |               |Channal_info       |

【Camera layout】


B1
<img src="../uploads/images/SCADAFieldData/Fig17.png" width="600">  

1F
<img src="../uploads/images/SCADAFieldData/Fig18.png" width="600"> 

2F
<img src="../uploads/images/SCADAFieldData/Fig19.png" width="600"> 

4F
<img src="../uploads/images/SCADAFieldData/Fig20.png" width="600"> 

5F
<img src="../uploads/images/SCADAFieldData/Fig21.png" width="600"> 

RF
<img src="../uploads/images/SCADAFieldData/Fig22.png" width="600"> 


6. 資料存取介面(API)       
--------------
(1)建立SSO User Id, APP Id      
建立SSO User Id- Sign up on SSO portal      

<img src="../uploads/images/SCADAFieldData/Fig23.png" width="600"> 

<img src="../uploads/images/SCADAFieldData/Fig24.png" width="600"> 

建立SSO APP Id      

<img src="../uploads/images/SCADAFieldData/Fig25.png" width="600"> 

取得SSO APP Id-點選"管理"     

<img src="../uploads/images/SCADAFieldData/Fig26.png" width="600"> 

(2)SSO Token取得,並放在存取API的Request Header      
Get access token:     

URL : /auth/native      
Method : POST      
Content-Type : application/json      
Payload :      

```
        var SSOObj =
        {
            "appId" : appID,
            "userId" : usrID
        }
```

Response :      

```
        {
         "tokenType": {string},
         "accessToken": {string},
         "expiresIn": {number},
         "refreshToken": {string}
        }                                          
```

帶入Access Token至request header      

```
        request(
        {
        	headers :
        	{
        		'Authorization' : "bearer "
        		{
        			access token
        		}
        	}
        }
        )  
```

(3)使用資料存取介面(API)      
● 通用感測器資料      
a. Load devices :     
URL : /common/v1/devices      
Method : GET      
Content-Type : application/json      
Response :      

```
        {
            "devices" : [
                {
                    "connected" : false,
                    "agentId" : "00000001-0000-0000-0000-305A3A77B1DA",
                    "name" : "PC001104",
                    "coordinates" : "",
                    "createTS" : "2017-04-19 07:39:35.679",
                    "did" : 2,
                    "parentId" : "",
                    "loginTS" : "2017-04-19 07:39:35.679"
                }
            ]
        }
```
b. Load plugins :     
URL : /common/v1/devices/10/plugins?agentId=00000001-0000-0000-0000-000BAB83A586&beginTs=2016-5-22%205:48:54:000&endTs=2017-5-23%205:48:54:000&amount=60&order=desc      
Method : GET      
Content-Type : application/json      
Response :      

```
        {
            "total" : 1,
            "Plugins" : [
                {
                    "plugin" : "WASCADAHandler"
                }
            ]
        }           

```

c.	Load sensors :     
URL : /common/v1/devices/10/sensors?agentId=00000001-0000-0000-0000-000BAB83A586&plugin=WASCADAHandler&beginTs=2016-5-22%205:53:51:000&endTs=2017-5-23%205:53:51:000&amount=60&order=desc      
Method : GET      
Content-Type : application/json      
Response :      

```
        {
         "total" : 60,
         "sensorIds" : [
        	 {
        		 "sensorId" : "/NPL/SCADA/11/JS_A1F01/JS_A1F01:PM10/Name"
        	 }
         ]
        }                              
```
d. Get sensor last data :          
URL : /common/v1/data/10/latestdata?agentId=00000001-0000-0000-0000-000BAB83A586&plugin=WASCADAHandler&sensorId=/NPL/SCADA/11/JS_A1F01/JS_A1F01:PM10/Name      
Method : GET      
Content-Type : application/json      
Response :      

```
        {
            "connected" : true,
            "itemList" : [
                {
                    "sv" : "JS_A1F01:PM10",
                    "sensorId" : "/NPL/SCADA/11/JS_A1F01/JS_A1F01:PM10/Name",
                    "ts" : "Thu May 18 20:35:32 UTC 2017"
                }
            ]
        }                            
```

e. Get sensor historical data :     
URL : /common/v1/data/12/histdata?agentId=cda43195-7a0a-4903-a533-d333d8c5f9d9&plugin=SCADA&sensorId=/P05_Building/ALKA_OA201TV:FOUT&beginTs=2017-5-21%206:5:37:000&endTs=2017-5-22%206:5:37:000&amount=60&order=desc      
Method : GET      
Content-Type : application/json      
Response :      

```
        {
          "connected" : false,
          "total" : 60,
          "itemList" : [
        	  {
        		  "v" : 0.1624845266342163,
        		  "sensorId" : "/P05_Building/ALKA_OA201TV:FOUT",
        		  "ts" : "2017-05-22 06:04:59:059"
        	  }
          ]
        }                     
```

美食街POS管理資料     
a. Get ECR amount :     
URL : /SQLMgmt/qryData      
Method : POST      
Content-Type : application/json      
Payload :      

```
        {
          "request" :
          {
        	  "conditions" : [
        		  {
        			  "item" :
        			  {
        				  "@operator" : ">",
        				  "@tableField" : "foodcourt_master.txn_time",
        				  "@value" : "2017-05-15 0:0:0"
        			  }
        		  },
        		  {
        			  "item" :
        			  {
        				  "@operator" : "==",
        				  "@tableField" : "foodcourt_master.ecr_no",
        				  "@value" : "0015"
        			  }
        		  }
        	  ],
        	  "conditions_op" :
        	  {
        		  "@value" : "AND"
        	  },
        	  "limit" :
        	  {
        		  "@value" : "10000"
        	  },
        	  "offset" :
        	  {
        		  "@value" : "0"
        	  },
        	  "orderBy" :
        	  {
        		  "item" :
        		  {
        			  "@tableField" : "foodcourt_master.txn_time",
        			  "@value" : "DESC"
        		  }
        	  },
        	  "selectFields" :
        	  {
        		  "item" : [
        			  {
        				  "@tableField" : "foodcourt_master.ecr_no"
        			  },
        			  {
        				  "@tableField" : "foodcourt_master.txn_no"
        			  },
        			  {
        				  "@tableField" : "foodcourt_master.TXN_TotSaleAmt"
        			  },
        			  {
        				  "@tableField" : "foodcourt_master.TXN_TotPayAmt"
        			  },
        			  {
        				  "@tableField" : "foodcourt_master.txn_time"
        			  }
        		  ]
        	  }
          }
        }
                      
```

Response :      

```
        {
          "result" :
          {
        	  "item" : [
        		  {
        			  "txn_totsaleamt" : 70,
        			  "txn_no" : 149,
        			  "ecr_no" : "0015",
        			  "txn_totpayamt" : 70,
        			  "txn_time" : "2017-05-22 13:59:35.0"
        		  }
        	  ]
          }
        }
```

b.Get ECR total amount :     
URL : /SQLMgmt/qryData      
Method : POST      
Content-Type : application/json      
Payload :      

```
        {
            "request" :
            {
                "conditions" :
                {
                    "item" :
                    {
                        "@operator" : ">",
                        "@tableField" : "foodcourt_master.txn_time",
                        "@value" : "2017-5-22 0:0:0"
                    }
                },
                "conditions_op" :
                {
                    "@value" : "AND"
                },
                "limit" :
                {
                    "@value" : "10000"
                },
                "offset" :
                {
                    "@value" : "0"
                },
                "orderBy" :
                {
                    "item" :
                    {
                        "@tableField" : "foodcourt_master.ecr_no",
                        "@value" : "ASC"
                    }
                },
                "selectFields" :
                {
                    "item" : [
                        {
                            "@tableField" : "foodcourt_master.ecr_no"
                        },
                        {
                            "@tableField" : "foodcourt_master.txn_no"
                        },
                        {
                            "@tableField" : "foodcourt_master.TXN_TotSaleAmt"
                        },
                        {
                            "@tableField" : "foodcourt_master.TXN_TotPayAmt"
                        },
                        {
                            "@tableField" : "foodcourt_master.txn_time"
                        }
                    ]
                }
            }
        }                      
```
Response :      

```
        {
        	"result" :
        	{
        		"item" : [
        			{
        				"txn_totsaleamt" : 75,
        				"txn_no" : 48,
        				"ecr_no" : "0011",
        				"txn_totpayamt" : 75,
        				"txn_time" : "2017-05-22 12:06:33.0"
        			}
        		]
        	}
        }
```

視訊串流資料     
a. Get VCM information :     
URL : //enumeration?enterpriseid=3      
EX : vcm.advantech.pcf-on-azure.net/enumeration?enterpriseid=3      
Method : GET      
Content-Type : text/plain      
Response :     

```
        {
         "Version" : "1.0.0.1",
         "ErrorCode" : "0",
         "ErrorMessage" : "",
         "vcminfo" : [
        	 {
        		 "vid" : "46",
        		 "password" : "1234",
        		 "dataport" : "8050",
        		 "domain" : "tw001.a-vcm.com",
        		 "vcmname" : "axdc-vms-01",
        		 "enterpriseid" : "3",
        		 "apiport" : "8089",
        		 "ivsid" : "IVS-00-D0-C9-F6-5D-59",
        		 "username" : "admin",
        		 "channum" : "16"
        	 }
         ]
        }                                     
  
```

b. Get channel information :     
URL :/chanenumeration?vid=46      
EX : cm.advantech.pcf-on-azure.net/chanenumeration?vid=46      
Method : GET      
Content-Type : text/plain      
Response :      

```
        {
            "Version" : "1.0.0.1",
            "ErrorCode" : "0",
            "ErrorMessage" : "",
            "chaninfo" : [
                {
                    "vid" : "46",
                    "channo" : "1",
                    "frames" : "4",
                    "channame" : "CCD1",
                    "id" : "95",
                    "resolution" : "1920 x 1080"
                }
            ]
        } 
```
c. Online :     
URL : /AdvStreamingService/Authority/Online      
EX : tw001.a-vcm.com:8050/AdvStreamingService/Authority/Online      
Method : PUT      
Content-Type : application/xml      
Payload :      

```
        <request>
        <username>UserName</username>
        <passwordt>Password</password>
        </request>
      
```

Response :     

```
        <result>
        <version>2.0.0.1</version>
        <SessionID>12321313123</SessionID>
        </result>

```
d. Get ECR total amount :          
URL :/AdvStreamingService/LiveStream      
EX :tw001.a-vcm.com:8050/AdvStreamingService/LiveStream      
Method : PUT      
Content-Type : application/xml      
Payload :      

```
        <request>
        <method>connection</method>
        <sessionID>SessionI</sessionID>
        <IVSID>IVSID</IVSID>
        <channel>Channel</channel>
        </request>
```

Response :      

```
        <result>
        <version>2.0.0.1</version>
        <state>OK</state>
        <mpd>http://10.50.62.96:8089/14860592796149706681/14860828001443792112/dashcast.mpd
        </mpd>
        </result>
```


● 智慧大樓資料      
a. Factory equipment historical tag data :          
URL : /common/v1/data/12/histdata?agentId=cda43195-7a0a-4903-a533-d333d8c5f9d9&plugin=SCADA&sensorId=/P01_Factory_Equipment/AdamFlagTest&beginTs=2017-5-21%206:5:37:000&endTs=2017-5-22%206:5:37:000&amount=60&order=desc      
Method : GET      
Content-Type : application/json      
Response :     
 
```
        {
            "connected" : false,
            "total" : 60,
            "itemList" : [
                {
                    "v" : 0.1624845266342163,
                    "sensorId" : "/P01_Factory_Equipment/AdamFlagTest",
                    "ts" : "2017-05-22 06:04:59:059"
                }
            ]
        }
```

● 智慧工廠資料 
a. Factory equipment historical tag data :   
URL : /common/v1/data/12/histdata?agentId=cda43195-7a0a-4903-a533-d333d8c5f9d9&plugin=SCADA&sensorId=/P02_Factory_Energy/ATML_SEBIA:I2&beginTs=2017-5-21%206:5:37:000&endTs=2017-5-22%206:5:37:000&amount=60&order=desc    
Method : GET    
Content-Type : application/json    
Response :    

```
        {
          "connected" : false,
          "total" : 60,
          "itemList" : [
        	  {
        		  "v" : 0.1624845266342163,
        		  "sensorId" : "/P02_Factory_Energy/ATML_SEBIA:I2",
        		  "ts" : "2017-05-22 06:04:59:059"
        	  }
          ]
        }                                 
```

