SCADA Portal User Guide      
=============

What is SCADA?      
------------

SCADA (Supervisory Control And Data Acquisition) is an automation management system of software and hardware elements for providing data acquisition, integration, analytics, and visualization technology in IoT.

The functionality of SCADA      
---------------

SCADA consists of three parts: cloud manager, account management.      
 

SCADA Cloud Manager      
=============

There are three layers in SCADA Cloud Manager: the SCADA node layer, the device layer, and the tag layer.      

<br/><img src="../uploads/images/SCADA/02.jpg" width="600"><br/>               


How to use the SCADA portal?      
--------------
**Getting Started**   
The procedure of WISE-PaaS connection setting   
In the beginning, user have to configure the project and the SCADA node on the WISE-PaaS/SCADA portal.   
The user can use the SCADA id to configure the connection setting on the WebAccess/SCADA.   
Then the user can sychonize the tag to the WISE-PaaS scada though communicating the specified MQTT message formate.

- Step1:Configure the project  on the  WISE-PaaS/SCADA portal
- Step2:Configure the SCADA node on the  WISE-PaaS/SCADA portal
- Step3:Configure the WISE-PaaS connection setting on the ground SCADA node
- Step4:Whitelist setting
- Step5:Upload the tag configuration and data withe the specified MQTT message formate
  

<br/>
<img src="../uploads/images/SCADA/35.jpg"  width="600"><br/>   



**General Usage-Flow**

- Sign in for SCADA portal      
- SCADA device management      
- SCADA account management      

**SCADA Menu Page**

The links of Cloud Manager or Dashboard are included in the menu page      

<br/><img src="../uploads/images/SCADA/07.jpg" width="70%"><br/>               

Direct to the Cloud Manager page by clicking "->" button      

SCADA Device Management      
----------------

Direct to the Cloud Manager page by clicking "->" button      

<br/><img src="../uploads/images/SCADA/08.jpg" width="70%"><br/>               

The default page is the device manager page, or choose the "Device Manager" item from device drop-down list      

<br/><img src="../uploads/images/SCADA/09.jpg" width="70%"><br/>               

SCADA Device Management-Project      
--------------------
The Project list display on the cloud manager page      

<br/><img src="../uploads/images/SCADA/19.jpg"  width="70%"><br/>               

<br/>Create Project: Click the "New Project" button       

<br/><img src="../uploads/images/SCADA/20.jpg"  width="70%"><br/>              

Edit Project
User can modify the project configuration by clicking "Edit" button.         
- Click the "..." button      
- Click the "Edit" button      
- Save the modified configuration <br/>         

<br/><img src="../uploads/images/SCADA/28.jpg">          


Delete Project 
When the project has been deleted. The SCADA nodes under the project would remove synchronically on the WebAccess/SCADA node by clicking "Delete" button.    
- Click the "Delete" button 
            

Create SCADA: Click the "New SCADA" button       

<br/><img src="../uploads/images/SCADA/27.jpg"  width="70%"><br/>               

View SCADA: Click the ">" button          

<br/><img src="../uploads/images/SCADA/21.jpg"  width="70%"><br/>              

The SCADA list display on the cloud manager page      

<br/><img src="../uploads/images/SCADA/10.jpg"  width="70%"><br/>               

SCADA Device Management-SCADA      
--------------------

- The status of SCADA: "●" (Green is online, Gray is off-line)         
- Direct to the device list page: Click the ">" button         
- View SCADA information: Click the "..." button     

<br/><img src="../uploads/images/SCADA/12.jpg" width="600"><br/>               

Edit SCADA   
<br/> 
When the specific properties of the SCADA node have been modified, the SCADA node would update synchronically on the WebAccess/SCADA node by clicking "Synchronize" button.      

- Click the "..." button      
- Click the "Edit" button      
- Save the modified configuration      


<br/> <img src="../uploads/images/SCADA/22.jpg"><br/>               

Delete SCADA
When the SCADA node has been deleted. The SCADA node would remove synchronically on the WebAccess/SCADA node by clicking "Delete" button.       
- Click the "Delete" button

SCADA Device Management-Device      
-------------------

<img src="../uploads/images/SCADA/13.jpg" width="70%">         

- Model: device type (ex: WebAccess SCADA Device)      
- Direct to the tag list page: Click the ">" button      
- View device information: Click the "..." button      

<br/><img src="../uploads/images/SCADA/14.jpg" width="600"><br/>               

Edit Device
When the specific properties of devices have been modified, the device can be updated synchronically on the WebAccess/SCADA node by clicking "Synchronize" button.       
- Click the "..." button
- Click the "Edit" button      
- Save the modified configuration      

<br/><img src="../uploads/images/SCADA/23.jpg"><br/>                     

Delete Device 
When the device has been deleted. The device would remove synchronically from on the WebAccess/SCADA node by clicking "Synchronize" button.                    
- Click the "Delete" button

SCADA Device Management-Tag            
--------------

<br/><img src="../uploads/images/SCADA/15.jpg" width="70%"><br/>                  

- Type: The type of tag (Analog/Discrete/Text)            
- Unit: The engineering unit of Tag (ex:%)            
- View tag information: Click the "..." button            

Edit Tag  
When the specific properties of tags have been modified, the WISE-PaaS whitelist tag can be updated synchronically on the WebAccess/SCADA node by clicking "Synchronize" button.            
- Click the "..." button            
- Click the "Edit" button            
- Save the modified configuration    
        
<br/><img src="../uploads/images/SCADA/24.jpg"> <br/>         

Delete Tag
When the tags have been deleted. The  WISE-PaaS whitelist tags would remove synchronically from on the WebAccess/SCADA node by clicking "Synchronize" button.     
- Click the "Delete" button

SCADA Device Management-Synchronize            
--------------
Synchonize the modified configuration to the WebAccess/SCADA whitelist tags            
- Direct to the SCADA page            
- Click the "Synchronize" button <br/>  
          
<br/><img src="../uploads/images/SCADA/25.jpg" width="70%"><br/>          

SCADA Device Management-Filter           
--------------
Click the "Filter" button        

<br/><img src="../uploads/images/SCADA/29.jpg" width="60%">    


SCADA Account Management      
=============

Account Management     <br/>
----------------
Account setting and user setting are included in the account management    

<br/> <img src="../uploads/images/SCADA/34.jpg"  width="40%"><br/>     

Account Management-Account     
----------------
Create Account:    <br/>
Click the "Add New Account" button  
User can configure the  email address, role type, privilege for the account 

<br/> <img src="../uploads/images/SCADA/30.jpg"  width="70%"><br/>     

Edit Account:     <br/> 
Click the "Setting" button          

<br/> <img src="../uploads/images/SCADA/31.jpg"  width="70%"><br/>   

Delete Account   
- Click the "Delete" button

  
Account Management-Role    
----------------
Create Role: Click the "Add New Role" button   
There are four scope for role setting:
- "edit_config": User has the authority to edit the configuration of the whole project
- "edit_value": User has the authority to edit the value of the tag
- "get_value":User has the authority to get the value of the tag
- "manage_account":User has the authority to manage the account on the WISE-PaaS/SCADA portal
      

<br/> <img src="../uploads/images/SCADA/32.jpg"  width="70%"><br/>     

Edit Role: Click the "Setting" button      


<br/> <img src="../uploads/images/SCADA/33.jpg"  width="70%"><br/>    


Delete Role   
- Click the "Delete" button
  