EI-Dashboard的认识和使用
===


EI-Dashboard概述
---

EI-Dashboard是一个基于html的引擎，用来可视化来自IoT设备的所有类型的实时和历史数据，同时提供了各种小组件和数据源，以帮助用户创建IoT Dashboard.

EI-Dashboard提供了以下功能：

* 提供多用户管理，每个登录用户都有自己的Dashboard配置。
* 为每个账户提供多个页面，最多8个。
* 提供各种数据源来获取数据(当前数量为8，可以扩展)。
* 提供各种Widget来显示数据(当前数量为19，可以扩展)。
* 提供单页配置的导出和导入。
* 提供两种主题：DeepDark/Clear White。
* 满足桌面和移动设备的RWD(响应式网页设计)要求。

EI-Dashboard与Azure SSO集成，通过Microsoft Azure Azure的注册帐户登录。

EI-Dashboard主布局
---

EI-Dashboard主界面由三部分组成：工具栏，网格，数据表。

![](images/EI-Dashboard_01.jpg)

1. 工具栏：工具栏提供仪表板管理的基本主要功能：用户，导入导出，添加组件，切换皮肤，小组件扩展指南，退出和数据源。
2. 网格：网格支持跨越多列的直观的拖放小组件。所有的小组件放置在网格中，显示数据表获取的数据源。在从数据源获取数据后，组件的值会自动更新。
3. 数据表：提供数据表的操作。包括添加，删除，切换，重命名工作表。

EI-Dashboard数据源
---

EI-Dashboard是一个数据源变动而更新的应用程序。一旦数据源更新，相应的小组件将被刷新。单击右上角数据源图标来管理数据源。
数据来源类型：

![](images/EI-Dashboard_02.jpg)

1. 时钟：以一定的时间间隔刷新显示当前时间。
2. JSON传递：从指定的URL中检索所需的json格式数据。
3. Yahoo Weather API：从雅虎检索指定城市的天气信息。
4. WebSocket-数据流：从构建一个Web socket来监听来自其他服务器的数据。这依赖于浏览器和安全性(SSL启用)。
5. WISE-PaaS实时数据：从WISE-PaaS服务器检索传感器实时数据。分配服务器URL，并按照”DEVICE”->”PLUGIN”->”SOURCE”定位传感器。
6. WISE-PaaS历史数据：从WISE-PaaS服务器检索传感器检索历史记录。分配服务器URL，并安装”DEVICE”->”PLUGIN”->”SOURCE”定位传感器。
7. WISE-PaaS获取ECR数据：检索指定电子收款机的每日收入详情。
8. WISE-PaaS获取ECR总计：检索所有电子收款机的每日收入细节。

数据源配置例如WISE-PaaS实时数据如下：

![](images/EI-Dashboard_03.jpg)

窗口小部件

小部件是在EI-DashBoard上显示数据的基本单位。所有用户需要做的是设置数据源，添加适当的窗口小部件，然后绑定要显示的值。
第一步是添加窗格，单击工具栏上的添加窗格图标。然后按添加小部件图标(+)将窗口小部件添加到窗格中。窗格可以容纳多个窗口小部件。

![](images/EI-Dashboard_04.jpg)

小部件类型：

* 文本：这是一个可以显示文本和sparkline图表的小部件。数据源是单个值，指定最后一层“v”的DATA，例如：datasources [“Co2”] [“itemList”] [“0”] [“v”]

	![](images/EI-Dashboard_05.jpg)

* 图片：这是一个可以显示图像的小部件。它用于显示图像，如Web相机。数据源是单个值，指定最后一层“v”的DATA，例如：datasources [“advantech”] [“itemList”] [“0”] [“v”]

	![](images/EI-Dashboard_06.jpg)

* HTML: 这是一个可以显示HTML的小部件。通常嵌入iFrame以显示外部页面，例如：HTML CONTENTS：<iframe frameBorder =“0”src =' http://www.advantech.com/'style =“width：100％; height：100％; overflow ：hidden;“/>

	![](images/EI-Dashboard_07.jpg)

* 指针：这是一个可以显示方向和价值的小部件。数据源是单个值，指定最后一层“v”的DATA，例如：datasources [“Co2”] [“itemList”] [“0”] [“v”]

	![](images/EI-Dashboard_08.jpg)

* 指示灯：该小部件在指定值的条件下亮起。1打开，并将0设置为OFF。数据源是单个值，指定最后一层“v”的DATA，例如：datasources [“Led”] [“itemList”] [“0”] [“v”]

	![](images/EI-Dashboard_09.jpg)

* Gauge: 这是一个可以显示仪表的小部件。数据源是单个值，指定最后一层“v”的DATA，例如：datasources [“Co2”] [“itemList”] [“0”] [“v”]
	
	![](images/EI-Dashboard_10.jpg)

* 风扇：这是一个可以显示图像风扇的小部件。1打开，并将0设置为OFF。数据源是单个值，指定最后一层“v”的DATA，例如：datasources [“Co2”] [“itemList”] [“0”] [“v”]

	![](images/EI-Dashboard_11.jpg)

* 进度栏：可以显示横向进度条的小部件。数据源是单个值，指定最后一层“v”的DATA，例如：datasources [“Co2”] [“itemList”] [“0”] [“v”]

	![](images/EI-Dashboard_12.jpg)

* RAG指标：这是一个可以根据状态显示不同灯光（0：红色，1：琥珀色，2：绿色）的小部件。数据源是单个值，指定最后一层“v”的DATA，例如：datasources [“Led”] [“itemList”] [“0”] [“v”]

	![](images/EI-Dashboard_13.jpg)

* 开/关：该小部件可以根据数据源切换传感器的开/关。数据源是单个值，指定最后一层“v”的DATA，例如：datasources [“GPIO”] [“itemList”] [“0”] [“v”]

	![](images/EI-Dashboard_14.jpg)

* NodeRed Threshold：此窗口小部件可以根据指定的Node-Red服务器的节点名称设置NodeRed的阈值。

	![](images/EI-Dashboard_15.jpg)

* 表：这是一个可以显示HTML表格的窗口小部件。数据源是一个多行值，指定数据源的数据源，例如：datasources [“0016”]

	![](images/EI-Dashboard_16.jpg)

* 图表：这是一个可以显示各种格式图表的小部件。数据源是一个多行值，指定数据源的数据源，例如：datasources [“0016”]

	![](images/EI-Dashboard_17.jpg)

* Google地图：这是一个可以显示具有多个标记的Google地图的小部件。数据源是一个多行的值，指定数据源的DATA，例如：datasources [“devices”]

	![](images/EI-Dashboard_18.jpg)

* IAQ曲线图：这是一个可以显示IAQ设备历史线图的小部件。数据源是一个多行的值，指定数据源的数据源，例如：datasources [“Co2”]

	![](images/EI-Dashboard_19.jpg)

* IAQ图片: 这是一个可以从IAQ设备显示集成空气质量图的小部件，例如：Co2，PM10，PM2.5 ....请指定每个数据源的相应值。

	![](images/EI-Dashboard_20.jpg)

* IAQ圆饼图: 这是一个小部件，可以在一段时间内显示IAQ设备的甜甜圈图。您可以设置适当的阈值来显示数据范围，并获得图表中心的平均值。数据源是一个单一的值，指定DATA到最后一层“v”，例如：datasources [“Co2”]

	![](images/EI-Dashboard_21.jpg)

* IAQ柱状图: 这是一个小部件，可以在一段时间内显示电子现金注册商的条形图。数据源是一个多行的值，指定数据源的数据源，例如：datasources [“ECR_Total”]

	![](images/EI-Dashboard_22.jpg)

* VCM视频小部件: 这是一个可以从VCM服务器显示实时视频的部件。您只需要指定服务器URL，企业ID和通道，并且不需要绑定数据源。
datasources [“ECR_Total”]
	
	![](images/EI-Dashboard_23.jpg)
