How to Deploy EI-Connect on WISE-1520

### Guide's Building Environment

本教程环境 Windows+CCS 

#### Perequisites

首先准备WISE-1520 + 开发环境

#### Installing EI-Connect on WISE-1520

- 下载SDK
	- 下载WISE-1520的SDK[   WISE-1520  SDK](http://downloadt.advantech.com/download/downloadsr.aspx?File_Id=1-1BKQAS6)
- 将工程导入到CCS中
    - Step01: 打开 CCS.
    - Step02: Choose Project -> Import CCS Projects from the menu.![](images/WISE1520_SDK_Import_project_01.png)
    - Step03: Select the Browse button in the Import CCS Eclipse Projects dialog.![](images/WISE1520_SDK_Import_project_02.png)
    - Step04: Select the CCS project directory of WISE-1520 SDK where you extracted before to root directory. For e.g. D:\WISE-1520_SDK_VX.X.X\project\ccs![](images/WISE1520_SDK_Import_project_03.png)
    - Step05: Import projects as below and press “Finish” button. 
Don’t check the “Copy projects into workspace” box.![](images/WISE1520_SDK_Import_project_04.png)
    - Step06: Select the Browse button in the Import CCS Eclipse Projects dialog, and Select the directory of CC3200 SDK from default path (C:\TI\CC3200SDK_1.1.0) as below.
    ![](images/WISE1520_SDK_Import_project_05.png)
    - Step07: Import “ti_rtos_config” project and check the 'Copy projects into workspace' as below and press “Finish” button.![](images/WISE1520_SDK_Import_project_06.png)
    - Step08: You can see imported projects as below in “Project Explorer”.![](images/WISE1520_SDK_Import_project_07.png)
    - Step09: Select the ti_rtos_config project in Project Explorer, and select Project -> Properties from the menu and setup the ti_rtos_config project configuration as below.![](images/WISE1520_SDK_Import_project_08.png)
    - Step10: Setup the ti_rtos_config project configuration as below and press “OK” button to complete setting.![](images/WISE1520_SDK_Import_project_09.png)

- 下载EI-Connect源码
	- 从github上下载[EI-Connect for WISE-1520](https://github.com/ADVANTECH-Corp/WISE-1520-EI-PaaS)
	- 解压,并将src文件夹中的目录替换WISE-1520的工程的SDK包中  ![](images/WISE-1520_01.png)
	- 在ccs中refresh工程   ![](images/WISE-1520_02.jpg)
	
- 编译和调试
    - Step01: Select the ti_rtos_config project in Project Explorer, and select Project -> Build Project to build it.![](images/WISE1520_SDK_Compile_debug_01.png)
    - Step02: Select the wise1520_demo project in Project Explorer, and select Project -> Build Project to build it.  
    ![](images/WISE1520_SDK_Compile_debug_02.png)
    - Step03: Set target configuration before debugging from CCS. Select View -> Target Configurations.![](images/WISE1520_SDK_Compile_debug_03.png)
    - Step04: Right click on “User Defined,” select “Import Target Configuration” and select the file CC3200.ccxml from xxx:\TI\CC3200SDK_1.1.0\cc3200-sdk\tools\ccs_patch\. Select the Copy files option when prompted.![](images/WISE1520_SDK_Compile_debug_04.png)
    - Step05: Set this new configuration as the default by right clicking on the file name as below.![](images/WISE1520_SDK_Compile_debug_05.png)
    - Step06: Check device connected from WISE-ED20 to PC using micro-USB cable and choose any terminal you like. (e.g., the snapshot is setting of Tera Term.)![](images/WISE1520_SDK_Compile_debug_06.png)![](images/WISE1520_SDK_Compile_debug_07.png)
    - Step07: Set into programming mode. Please check pin1 of SW2 to “ON” on WISE-ED20.![](images/WISE1520_SDK_HW_Siwtch_wiseed30_programming_mode.png)
    - Step08: Launch application. Select the wise1520_demo project in Project Explorer, and then click the debug icon as below to download code to the device and begin debugging. Press F8 to begin execution.
    ![](images/WISE1520_SDK_Compile_debug_08.png)
    - Step09: User can see snapshot as below after begin execution.![](images/WISE1520_SDK_Compile_debug_09.png)
    
- 将数据上传至WISE-PaaS
    - 完成以上步骤后已将环境搭建完成。
    - 在项目中将wise1520_demo_main.c中 AGENT_DEFAULT_SERVER_NAME PAAS_ID PAAS_PW 修改成你所拥有的
    ![](images/WISE-1520_03.jpg)
    - 重复编译和调试的步骤即可连接WISE-PaaS并上传数据
    - 在调试窗口中可以查看到WISE-1520向WISE-PaaS上传一条信息    ![](images/WISE-1520_04.jpg)

- 查看WISE-PaaS的RabbitMQ所收到的数据
    - 首先在Linux环境中安装mosquitto的broker`apt-get install mosquitto*`
    - 安装成功后使用`mosquitto_sub`来订阅WISE-1520的EI-connect发布的信息![](images/WISE-1520_05.jpg)

