EI-Connect 介绍与开发入门
===
### 一、EI Connect基本介绍 ###
---
### 1. 基本概要
  首先，我们来了解一下，EI-Agent可以做些什么事。在物联网应用中，底层设备本身不具有太强的计算能力，通常他们的主要任务就是采集数据，然后将采集到的数据发送到云端统一存储和进一步处理。因此，在物联网应用中，设备与云端Server的连接是必不可少、也是极其重要的一部分。EI-Agent可以很好地完成这一任务：它可以在底层设备和IoT/WISE-PaaS Server之间进行通信和信息交换，进一步地，它可以发送服务端给底层设备传送的命令。

 现在，我们可以“给EI-Agent是什么”这个问题提供一个回答了：EI-Connect是一个库，更确切来说，是若干个库，它被实现了完成在底层设备和IoT/WISE-PaaS之间进行通信和信息交换。EI-Connect提供了许多user-friendly、intelligence的接口，可以用来协助用户快速地开发出安全的agent应用（用来连接IoT/WISE-PaaS Server）。

 EI-Agent的实现决定了它有以下两个优点：
 1.	标准化：EI-Agent采用的通信协议是MQTT，并且交换的信息遵循JSON格式。
MQTT凭借着“低功耗”、“网络带宽要求低”等优点以及若干“贴心”的设计（如遗嘱机制），在物联网行业有宽广的发展空间。目前，MQTT协议已经被IBM、亚马逊、Microsoft的IoT hub所支持。
MQTT协议是一个基于客户端-服务端的消息分布/订阅传输协议。客户端可以向服务端（更确切来说，应该叫broker）publish某个topic的消息、或者subscribe某个topic的消息。这样，当broker收到某个topic的消息，就会向那些subscribe这个topic的客户端推送这个消息。
更多的关于MQTT的介绍可以参考：
- https://www.gitbook.com/book/mcxiaoke/mqtt-cn/details
- https://mosquitto.org/

 2.	可移植性：EI-Connect使用C语言（遵循ANSI C标准）编写。而C编译器在大多数的系统均可用（通常也是大多数系统能用的第一个编译器）。

### 2. EI Connect的架构

 在了解EI-Agent的其他优点前，我们先来看一下EI-Agent的架构，如图1.1所示![](images/EI-Connet_01.jpg)

 EI-Agent的架构非常的简单，它只有两个主要的部分：WISE Core和WISE Connector。这个架构也体现了EI-Connect设计的两个目的：

1.	轻量化：EI-Connect框架非常简单，用户也可以用它来实现一个轻量级的应用程序。
这一点在物联网中非常重要。在过去，研华的WISE-Agent也可以提供与Server的通信功能，然而除此之后WISE-Agent也提供了许多其它的功能。而这就无可避免地导致了WISE-Agent是一个相对庞大的软件。将这样一个庞大的软件移植到一个计算能力较差、资源比较紧缺的平台上是非常困难的。而EI-Connect注重连接的功能，它从过去的软件实现中提取出了核心的连接模块，称为WISE Core。我们可以轻易地将这个小型的库移植到那些资源紧缺的平台上。
2.	多连接协议：I-Connect的另一个组件是WISE Connector，它可以用来使用多种不同的连接协议。
目前，EI-Connect实现了MQTT的连接协议。在后续，将实现AMQP、Web Socket、HTTP等协议。为了支持多种连接协议，我们为EI-Connect定义了通用的API，称之为EI-Connector API。我们可以在编译时更改Connector模块，以连接不同的云Server。

---
### 3. EI Connect的在Windows下的开发
 1.	下载source code载[EI-Connect](http://advgitlab.eastasia.cloudapp.azure.com/EI-Connect/EI-Connect)，并解压，如图所示 ![](images/EI-Connect_02.jpg)
 2.	使用vs2013导入EI-Connect的工程。
 3.	打开时可能出现如图所示的窗口，直接选择确定即可![](images/EI-Connect_03.jpg)
 4.	接下来可能出现如图所示：打个勾后直接选择是即可![](images/EI-Connect_04.jpg)
 5.	运行sample，例如，要运行WISECoreSample，先在WISE Core项目处点击右键，然后选择“设为启动项目”。如图![](images/EI-Connect_05.jpg)
 6.	启动执行即可（最好先在生成菜单下进行一次“重新生成解决方案”）。结果如图所示![](images/EI-Connect_06.jpg)


---
### 二、EI Connect基本介绍 ###
---

 在这一部分，我们将了解EI Connect的几个重要的API（注意：在这里主要讲述的是WISE Core提供的API，这些API会调用WISE Connector的API），包括了初始化API、连接API、publish和subscribe API（封装了mosquitto）等，同时可以了解EI Connect的回调函数机制是如何工作的，通过设置回调函数，EI Connect可以处理连接确认、断开连接、收到消息等事件。
### 1.	core_initialize API
- bool core_initialize(char* strClientID, char* strHostName, char* strMAC, void* userdata);
    - 描述：WISE Core的初始化API，如果这个API没有被调用，则其它所有的WISE Core - - -   - API都将返回false。
    - 参数：
        - strClientID，一个指向表示客户端ID字符串的指针。客户端ID的格式为UUID格式：xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx.
        - strHostName，一个指向表示客户端名字的字符串的指针。
        - strMAC：表示客户端的MAC地址
        - userdata：指向用户数据
    - 返回值：true/false

- 在这个API中，将填充一个core_contex_t类型的结构全局变量：g_tHandlerCtx（注意：这个变量被声明为void *类型，但是它实际上指向core_contex_t类型。在后续使用其它API中，都需要这个变量）。
     >core_contex_t类型的定义如下：

```
typedef struct{
	/*clinet info, user must define*/
	char strClientID[DEF_DEVID_LENGTH];
	char strHostName[DEF_HOSTNAME_LENGTH];
	char strMAC[DEF_MAC_LENGTH];
	/*product info*/
	char strSerialNum[DEF_SN_LENGTH];
	char strVersion[DEF_MAX_STRING_LENGTH];
	char strType[DEF_MAX_STRING_LENGTH];
	char strProduct[DEF_MAX_STRING_LENGTH];
	char strManufacture[DEF_MAX_STRING_LENGTH];
	char strTag[DEF_MAX_STRING_LENGTH];
	char strParentID[DEF_DEVID_LENGTH];
	
	/*account bind*/
	char strLoginID[DEF_USER_PASS_LENGTH];
	char strLoginPW[DEF_USER_PASS_LENGTH];

	/*client status*/
	WiConn_t conn;
	lite_conn_status iStatus;
	int pSocketfd;

	CORE_CONNECTED_CALLBACK on_connect_cb;
	CORE_LOSTCONNECTED_CALLBACK on_lostconnect_cb;
	CORE_DISCONNECT_CALLBACK on_disconnect_cb;
	CORE_MESSAGE_RECV_CALLBACK on_msg_recv_cb;
	CORE_RENAME_CALLBACK on_rename_cb;
	CORE_UPDATE_CALLBACK on_update_cb;
	CORE_SERVER_RECONNECT_CALLBACK on_server_reconnect;
	CORE_GET_CAPABILITY_CALLBACK on_get_capability;
	CORE_START_REPORT_CALLBACK on_start_report;
	CORE_STOP_REPORT_CALLBACK on_stop_report;
	CORE_QUERY_HEARTBEATRATE_CALLBACK on_query_heartbeatrate;
	CORE_UPDATE_HEARTBEATRATE_CALLBACK on_update_heartbeatrate;
	CORE_GET_TIME_TICK_CALLBACK on_get_timetick;
	bool bInited;
	char strPayloadBuff[4096];
	char strTopicBuff[128];
	int iErrorCode;
	long long tick;
	void* userdata;
}core_contex_t;

```
> 1.	定义中的前三个成员正对应着我们传递给core_initialize函数的三个参数（strClientID、strHostName、strMAC）。
> 2.	我们可以看到core_contex_t结构中包含了多个函数指针，这是WISE Core用来处理某些事件的callback函数。callback函数即回调函数。回调函数就是一个通过函数指针来调用的函数。我们把一些函数的指针先保存下来（或者作为参数进行传递，这个过程可以称之为“注册callback函数”）。在程序后续的运行中，如果发生了某件事件，程序就通过发生的事件的类型，得到对应的函数指针，并通过这个函数指针来调用相应的函数来处理这一事件。例如，在EI Connect运行过程中， EI Connect收到Server发送的一个Connect Ack时，EI Connect的on_connect回调函数就会执行。
> 3.	从函数指针名称我们也可以获得一些回调函数的信息。例如，on_connect_cb就是连接成功的callback函数、on_disconnect_cb是断开连接时调用的callback函数、on_msg_recv_cb是客户端收到消息时调用的callback函数……我们先对这些建立起一个概念。

---
### 2.	设置callback函数的API
- 在core_contex_t类型的g_ tHandlerCtx中，包含了几个函数指针。在EI- Connect与服务端的交互过程中，收到服务端的某些请求报文时，会调用对应的函数指针，callback函数。这些函数指针是API来设置的。这些API、设置的函数指针和相应的函数指针的被执行的触发事件总结如下表：
    - on_connect_cb	连接成功后调用的callback	
    - on_lostconnect_cb	连接意外断开时的callback	
    - on_disconnect_cb	断开连接的callback	
    - on_msg_recv_cb	收到（此前订阅过的）消息的callback	
    - on_rename_cb	rename命令触发的callback
    - on_update_cb	update命令触发的callback	
    - on_server_reconnect	重连命令触发的callback	
    - on_get_capability	get_capabiliy命令触发的问题	
    - core_iot_callback_set
    - on_start_report	start_report命令触发的callback	
    - on_stop_report	stop_report命令触发的callback	
    - on_query_heartbeatrate	查询心跳速率命令触发的callback	
    - on_update_heartbeatrate	更新心跳速率命令触发的callback	
    - on_get_timetick	获取时间戳命令触发的callback
- 这些API会将相应的callback函数设置在全局变量g_ tHandlerCtx中。后续的API会在处理过程中通过这个全局变量来处理相应的事件。
- on_connect_cb callback函数的实现
    - 根据MQTT协议，客户端和服务端建立连接请求时，会发送一个Connect Command的消息（在这个消息中包含着连接使用的账号和密码、will信息等）；服务端收到请求后，如果允许连接就会向客户端发送一个Connnect Ask。在实现中，通常在收到Connect Ask后，就会调用相应的callback函数（此前设置的on_connect_cb，上面设置的callback函数其实也只是设置MQTT连接实例的回调函数）。
    - on_connect_cb函数一般可以实现为“创建一个新的线程”。在这个新的线程中，我们可以实现为每隔一段时间就调用WISE Core发送数据的API（如下所述，这个API是WISE Core）向Server发送消息。当然，我们可能还需要另一个线程来完成获取设备数据的任务。以下这段代码，就描述了on_connect_cb创建的线程执行的函数（当然，这里只是一个简单的sample）：
```
    void* threadconnect(void* args)
	    {
		char strRecvTopic[256] = { 0 };
		long long nextHeartbeat = 0;
		long long nextReport = 0;
		core_device_register();
		SubscribeTopic();
		while (true)
		{
			long long curTime = get_timetick(NULL);
			if (nextHeartbeat < curTime)
			{
				if (nextHeartbeat == 0)
					nextHeartbeat = curTime;
				nextHeartbeat += (g_iHeartbeatRate * 1000);
				core_heartbeat_send();
			}
			if (g_bReportData)
			{
				if (nextReport < curTime)
				{
					if (nextReport == 0)
						nextReport = curTime;
					nextReport += (g_iReportInterval * 1000);
					//send report data
					sendReportData(curTime);
				}
			}
			else	{
				nextReport = 0;
			}
			usleep(100);
		}		pthread_exit(0);
		return NULL;	}
```
---
### 3. core_connect函数
- bool core_connect(char* strServerIP, int iServerPort, char* strConnID, char* strConnPW);
    - 描述：此API的用于连接服务器，其中服务器的地址由参数列表指定。包括服务器的IP、端口号、用户名以及密码。
    - 参数：
        - strServerIP：Server的地址。
        - iServerPort：Server的端口（MQTT为1883）
        - strConnID：用于登录Server的账号名
        - strConnPW：用于登录Server的密码
    - 返回值：true/false
    - sample 如下:
    
```
    char g_strServerIP[64] = "wise-msghub.eastasia.cloudapp.azure.com"; // MQTT broker URL or IP
    int g_iPort = 1883; // MQTT broker listen port, keep 1883 as default port.
    char g_strConnID[256] = "0e95b665-3748-46ce-80c5-bdd423d7a8a5:631476df-31a5-4b66-a4c6-bd85228b9d27"; //broker connection ID
    char g_strConnPW[64] = "f3a2342t4oejbefc78cgu080ia"; //MQTT broker connection password
    core_connect(g_strServerIP, g_iPort, g_strConnID, g_strConnPW);
```

---
### 4. 消息的publish和subscribe
- bool core_publish(char const * topic, void * pkt, long pktlength, int retain, int qos);
    - 描述：
        - 通过MQTT向Server publish某个topic的消息。
    - 参数：
        - topic：publish消息的topic
        - pkt：消息的payload
        - pktlength：消息的长度（字节单位）
        - retain：保留字段
        - qos：服务质量（MQTT的服务质量有3个等级，0：表示只发送一次；1：表示保证至少收到一次；2：保证只收到一次，但因为我们的MQTT Server是Rabbit MQ的MQTT Adaptor，它不支持QoS为2的报文）
    - 返回值：true/false
- bool core_subscribe(char const * topic, int qos)
    - 描述：
        通过MQTT向Serversubscribe某个topic的消息。
    - 参数：
        - topic 订阅topic
        - qos：服务质量（MQTT的服务质量有3个等级，0：表示只发送一次；1：表示保证至少收到一次；2：保证只收到一次，但因为我们的MQTT Server是Rabbit MQ的MQTT Adaptor，它不支持QoS为2的报文）
    - 返回值：true/false
 在EI Connect与Server建立起连接后，Server通常会向EI Connect发送某个command。这个command会携带在某一个MQTT报文中，MQTT报文有一个对应的topic（在后面的我们将看到，Server发送给EI Connect的command报文topic的后缀为“agentactionreq”。然而，EI Connect必须向broker subscribe这个主题，broker才会转发这样topic的消息给EI Connect。因此，在连接完成后，EI Connect需要调用core_subscribe某些感兴趣的topic的消息。这些是用户需要完成的：他们可以选择要处理的某些topic的报文。

 EI Connect会把subscribe的所有topic组织成一个链表，链表项定义如下所示：

```
    typedef struct topic_entry
    {
    	char name[128];
    	void* callback_func;
    	struct topic_entry *prev;
    	struct topic_entry *next;
    }topic_entry_st;
    
```
 其中，name为subscribe的topic，callback_func函数指针则是与该topic对应的callback函数。EI Connect收到一个消息时，会触发执行相应的callback函数。而在这个callback函数中，会根据消息的topic在subscribe topic链表寻找对应的项，如果找到了相匹配的项，就调用对应的callback函数来处理这个消息。

 EI Connect将注册这个callback函数隐藏在core_subscribe的实现中。在core_subscribe中，会使用一个default的函数来作为所有subscribe topic的处理函数，如下：
 - 在core_subscribe->core_ex_subscribe-> wc_ex_subscribe-> WiCarEx_MQTT_Subscribe
 - 在调用链中WiCarEx_MQTT_Subscribe调用使用了一个名为wc_ex_message_callback的函数指针，这个也就是用来处理所有topic的callback函数：WiCarEx_MQTT_Subscribe(pmosq->mosq, topic, qos,wc_ex_message_callback);

---
### 5. 注册API：core_device_register
- bool core_device_register();
    - 描述：
        - 这个API的作用是向Server发送一个register消息，它是握手协议的一部分，告知Server有一个新的设备已经连接。
    - 返回值：true/false

	这个 API通常在MQTT建立起连接后先执行，所以，通常可以放在on_connect_cb callback函数来调用。如下图是使用wireshark工具抓取的相应的报文：
 ![](images/EI-Connect_07.jpg)
 ![](images/EI-Connect_08.jpg)

 由上图可以发现这个register消息中，包含了EI Connect宿主机的许多信息。例如:hostname、mac地址、product (name)、sn号码、tag、版本号等。
 - EI Connect与Server断开连接时，发送的是unregister消息，其中status是“status:0”。
 - 更详细的描述、例子请参考：
[EI Connect Documentation](http://advgitlab.eastasia.cloudapp.azure.com/WISE-PaaS-Documentation/Documentation/blob/master/documents/EI-Connect/wisecore-api.md)

---
### 三、EI Connect消息topic的规则及含义###
---
### 1. MQTT的topic定义如下：
 - 从Server到Agent："/wisepaas/custom/agentId/function/req"
 - 从Agent到Server："/wisepaas/custom/agentId/function/ack"

### 2. MQTT的topic及其含义：
topic | define
---|---
Agent Registration Topic | /wisepaas/device/<agentId>/agentinfoack
Will Message Topic | /wisepaas/device/<agentId>/willmessage        or /wisepaas/device/<serverId>/willmessage
Command Topic	| /wisepaas/device/<agentId>/agentactionreq
 Response Topic	|/wisepaas/device/<agentId>/agentactionack
 Report Data Topic	|/wisepaas/device/<agentId>/devinfoack
Heartbeat Topic	|/wisepaas/device/<agentId>/notifyack
>更多的细节以及消息的格式请参考[EI Connect Handshake protocol](http://advgitlab.eastasia.cloudapp.azure.com/WISE-PaaS-Documentation/Documentation/blob/master/documents/EI-Connect/handshake-protocol.md)