"快速學習 WISE-PaaS"
====


認識 WISE-PaaS
---

WISE-PaaS平台為提供 Industrial Edge to Cloud 快速聯結機制，協助客戶迅速開發、佈署、營運設備連網管理、大數據分析預測及可視化等創新雲服務之首選雲平台。

SaaS應用服務開發商可以利用WISE-PaaS平台上強大的開發與佈署工具，快速開發專業等級的物聯網應用服務，上線營運與收費。平台具備多租戶功能，及彈性伸縮的功能，可以依據服務的需求，隨時增減服務容量，可以應付秒殺級服務需求，在使用量低時也能有效節省成本。

同時針對開發人員可透過專為開發者打造的 Technical Portal 取得相關的技術資訊。

![](images/WISE-PaaS.jpg)

WISE-PaaS 有下列特點可以充分滿足客戶的需求:

1. 客戶可以簡單的選擇他們需要的軟體服務，使客戶的業務快速地擴展與加速。

2. WISE-PaaS可以在不同的區域有大量穩定地連接的裝置。

3. WISE-PaaS可以適應不同國家的雲端基礎架構，同時也支援客戶私有雲的需求。

4. WISE-PaaS擁有完善的大數據和機器學習服務。
 
5. WISE-PaaS 整合第第三方軟體來協助客戶拓展業務。


WISE-PaaS 上提供的服務
---

平台上提供[資料管理](https://technical-portal.wise-paas.com/services.html#anchorService-1)、[設備管理](https://technical-portal.wise-paas.com/services.html#anchorService-2)、[解決方案](https://technical-portal.wise-paas.com/services.html#anchorService-3)、[視覺化工具](https://technical-portal.wise-paas.com/services.html#anchorService-4)以及[資料分析](https://technical-portal.wise-paas.com/services.html#anchorService-5)等五類服務。

資料管理包括 [MongoDB](https://technical-portal.wise-paas.com/card-mongodb.html)、 [PostgreSQL](https://technical-portal.wise-paas.com/card-postgresql.html)、 [Common Data Service](https://technical-portal.wise-paas.com/card-common-data-service.html), IoT HUB(https://technical-portal.wise-paas.com/card-iot-hub.html)等，主要讓開發商可以將聯網設備的資料送到雲端儲存。

設備管理包括 [設備管理 RMM](https://technical-portal.wise-paas.com/card-rmm.html) 與 [Condor DM 服務](https://technical-portal.wise-paas.com/card-condor-dm.html)，讓開發商可以對聯網設備進行管理。

解決方案包括[RMM](https://technical-portal.wise-paas.com/doc/document-portal.html#RMM-1)、[SCADA](https://technical-portal.wise-paas.com/doc/document-portal.html#SCADA-1)、[Condor DM服務](https://technical-portal.wise-paas.com/doc/document-portal.html#CondorDM-1)、[VCM](https://technical-portal.wise-paas.com/doc/document-portal.html#VCM-1)、[Kalman Filter](https://technical-portal.wise-paas.com/doc/document-portal.html#Analytics-1)

視覺化工具包括Freeboard與Node-RED。

資料分析預計提供大數據分析工具。


WISE-PaaS 如何提供開發者使用
---

為省去開發者寫程式的麻煩，平台服務除了提供開源碼工具例如Dashboard 的拖拉工具 [Freedboard](https://technical-portal.wise-paas.com/doc/document-portal.html#EIDashBoard-1)，Freeboard是一種基於 HTML 的引擎進行可視化所有種類的實時和歷史數據 , 它提供了各種小工具和設備 IoT 資料來源 , 以幫助用戶創建 IoT 儀表板。


以及聯網設備處理邏輯的 [Node-RED](https://technical-portal.wise-paas.com/doc/document-portal.html#NodeRed-1)。Node-RED可以將連線的硬體裝置、 API和線上服務過透過圖形介面整合的一種編譯工具、它提供了一種基於瀏覽器的編輯器 , 可以讓您很容易的利用單擊的方式啟動圖形介面中的各種功能的節點運行。

![](images/Node-RED.jpg)


上述工具讓開發者可以方便開發前端 IoT 應用服務外，也提供研華專為管理 IoT 設備開發的 WebAccess 供開發者選用。開發商透過圖形介面即可輕鬆完成服務開發。


WISE-PaaS Management Portal
---

WISE-PaaS 提供[開發者管理介面](https://technical-portal.wise-paas.com/doc/document-portal.html#ManagementPortal-1)，方便開發者了解服務應用的執行與使用情形。 同時WISE-PaaS 提供 [command line](https://technical-portal.wise-paas.com/doc/document-portal.html#PaasAgent-1) 及 Management GUI 兩種佈署方式。

![](images/Management-Portal.jpg)


如何讓裝置與 WISE-PaaS 進行溝通
---

[WISE-Agent](https://technical-portal.wise-paas.com/doc/document-portal.html#PaasAgent-1) 是 WISE-PaaS 所提供的軟體開發框架，能夠讓裝置與 WISE-PaaS 進行溝通，它提供了眾多兼具直覺易用與高度智慧的整合性界面，可以加快開發速度，增強系統安全性。

至於如何取得自己的裝置的回報數據，首先必須將裝置部署WISE-Agent，接著使用Commom Data Service 所提供之 [RESTful API](https://technical-portal.wise-paas.com/doc/document-portal.html#CommonDataService-1)，即可以簡單取得裝置自身資訊或是其所回報之資料。

![](images/WISE-Agent.jpg)

參考範例
---

你的應用程序可能是什麼樣子，它可能如何設計？ 來看看我們提供的[範例程式](https://technical-portal.wise-paas.com/doc/document-portal.html#EIDashBoard-2)。

