IoT Hub的初步学习和使用
===

IoT Hub概述
---

IoT Hub是一种机器到机器的物联网连接工具。它是一种全面管理的服务，可实现数百万个IoT设备和解决方案后端之间的可靠和安全的双向通信。IoT Hub是一种基于协议的消息解决方案，专为云计算和现代广泛分布的Web应用程序而设计。这是云消息传递的实际标准，也是高级消息队列协议(AMQP)的领先实施者，这是高成本的专有商业消息传递技术的开放标准替代方案。

IoT Hub有如下特征：

(1)	异步消息
	支持多种消息协议、消息队列、传送确认、灵活的路由到队列以及多种交换类型。

(2)	规模
	IoT Hub可扩展到数以百万计的同时连接的设备和数百万的每秒事件。

(3)	可靠性
	IoT Hub提供各种功能，让您可靠地获得性能，包括持久性，发货确认，发布商确认以及高可用性。
(4)	多协议
	IoT Hub通过各种消息传递协议支持消息传递。

(5)	支持多种语言的客户端
	支持常见的变成语言的IoT Hub客户端。

(6)	管理UI
	IoT Hub拥有易于使用的管理用户界面，可让您监视和控制消息代理的各个方面。

(7)	插件系统
	IoT Hub使用各种插件，以不同的方式进行扩展，您还可以编写自己的插件。

RabbitMQ的介绍
---

WISE-PaaS的IoT Hub使用的是RabbitMQ，RabbitMQ是基于AMQP(高级消息队列协议)的一个开源实现，服务端使用Erlang语言编写， 支持多种客户端，如：Python、Ruby、.NET、Java、JMS、C、PHP、ActionScript、XMPP、STOMP等，支持AJAX。用于在分布式系统中存储转发消息，在易用性、扩展性、高可用性等方面表现不俗。

下边介绍RabbitMQ中的一些基础概念：

* ConnectionFactory、Connection、Channel
	ConnectionFactory、Connection、Channel都是RabbitMQ对外提供的API最基本的对象。Connection是RabbitMQ的socket连接，它封装了socket协议相关逻辑部分逻辑。ConnectionFactory为Connection的制造工厂。Channel是我们与RabbitMQ交互的最重要的一个接口，我们大部分的业务操作是在Channel这个接口中完成的，包括定义Queue、定义Exchange、绑定Queue与Exchange、发布消息等。

* Queue
	
	队列(Queue)是RabbitMQ的内部对象，用于存储消息，如下图所示

	![](images/IoT-Hub_01.jpg)

	RabbitMQ中的消息都只能存储在Queue中，生产者(P)生产消息并最终投递到Queue中，消费者(C)可以从Queue中获取消息并消费。
	多个消费者可以订阅同一个Queue，这时Queue中的消息会被平均分摊给多个消费者进行处理，而不是每个消费者受到所有消息并处理。

	![](images/IoT-Hub_02.jpg)

* Message acknowledgement
	
	在实际应用中，可能会发生消费者受到Queue中的消息，但没有处理完成就宕机或出现其他意外的情况，这种情况下就可能会导致消息丢失。为了避免这种情况发生，RabbitMQ要求消费者在消费完消息后发送一个确认ack给RabbitMQ，RabbitMQ收到ack后才将该消息从Queue中移除，如果RabbitMQ没收到ack并且检测到消费者的RabbitMQ断开，则RabbitMQ会将该消息发送给其他消费者进行处理。这里不存在超时的概念，一个消费者处理消息时间再长也不会导致该消息被发送给其他消费者，除非它的RabbitMQ连接断开。

* Message durability
	
	如果我们希望即使在RabbitMQ服务重启的情况下，也不会丢失消息，我们可以将Queue和Message设置为可持久化的(durable)，这样可以确保绝大部分情况下我们的RabbitMQ消息不会丢失。但依然解决不了小概率丢失事件的发生(如RabbitMQ服务器已经收到生产者的消息，但还没来得及持久化该消息时RabbitMQ服务器就断电了），如果我们需要对这种小概率事件也要管理起来，那么我们要用到事务。由于这里仅为RabbitMQ的简单介绍，所以这里将不讲解RabbitMQ相关的事务。

* Prefetch count

	前面我们讲到如果多个消费者同时订阅同一个Queue中的消息，Queue中的消息会被平摊给多个消费者，这是如果每个消费者的处理时间不同，就可能导致某些消费者一直在忙，而另外一些消费者很快处理完后一直处于空闲状态。我们可以通过设置prefetchCount来限制Queue每次发送给每个消费者的消息数。消费者处理完消息后Queue再给该消费者发送prefetchCount数目的消息。
	如下图所示，两个消费者C1和C2都被设置prefetch数量为1。


	![](images/IoT-Hub_03.jpg)

* Exchange

	在上边我们看到生产者将消息投递到Queue中，但实际上RabbitMQ中，生产者将消息发送给Exchange，再由Exchange将消息路由到一个或者多个Queue中。Exchange将什么消息路由到哪些Queue中存在一些规则，详见下边Binding部分。

* Routing key

	生产者在将消息发送给Exchange的时候，一般会指定一个routing key，来指定这个消息的路由规则，而这个routing key需要与Exchange Type及binding key联合使用才能最终生效，也就是说，routing key、Exchange Type和binding key一起决定了这个消息如何被Exchange路由。
	在Exchange Type与binding key固定的情况下（在正常使用时一般这些内容都是固定配置好的），我们的生产者就可以在发送消息给Exchange时，通过指定routing key来决定消息流向哪里。
	注意：RabbitMQ为routing key设定的长度限制为255 bytes。
	
* Binding key

	在绑定Exchange和Queue时，会指定一个Binding key；消费者将消息发送给Exchange时，会指定一个Routing key；当Binding key与Routing key 匹配时，消息将会被路由到对应的Queue中（注意，如上文所述，消息被路由到哪些queue，还受Exchange Types的影响）。
	Binding key 并不是所有情况下都生效，还要依赖于Exchange Type，如fanout类型的Exchange就会无视Binding key，将消息路由给所有绑定到该Exchange的Queue。

* Exchange Types

	RabbitMQ常用的Exchange Type有fanout、direct、topic、headers这四种。

	(1)	fanout
		
	fanout类型的Exchange路由规则比较简单，它会发送到给Exchange的消息路由到所有与它绑定的Queue中。

	(2)	direct

	direct类型的Exchange路由会把消息路由到那些Binding key与Routing key完全匹配的Queue中。

	(3)	topic

	direct类型需要完全匹配Binding key和Routing key，这种严格的匹配方式在很多情况下不能满足实际业务需求。topic类型的Exchange在匹配规则上进行了扩展，它与direct类型的Exchange相似，也是将消息路由到Binding key与Routing key相匹配的Queue中，但匹配规则有些不同。它约定：

	* Binding key和Routing key都是由”.”分隔的字符串
	* Binding key中存在两种特殊字符’*’与’#’，用于模糊匹配，其中’*’用于匹配一个单词，’#’用于匹配零个或多个单词

	(4)	headers
	
	headers类型的Exchange不依赖与Routing key与Binding key的匹配规则来路由消息，而是根据发送的消息内容中的headers进行匹配。

	在绑定Queue与Exchange时指定一组键值对；当消息发送到Exchange时，RabbitMQ会取到该消息的headers（也是一个键值对的形式），对比其中的键值对是否完全匹配Queue与Exchange绑定时指定的键值对；如果完全匹配则消息会路由到该Queue，否则不会路由到该Queue。

使用IoT Hub
---

在cmd命令行界面中，cf login登录后，使用cf bind-service [app name] [service name] 命令将app和Rabbitmq服务绑定后

![](images/IoT-Hub_04.jpg)

使用 cf env [app name]命令可以看到，app的环境变量增加了RabbitMQ的相关变量

![](images/IoT-Hub_05.jpg)


这样我们代码中可以通过获取环境变量得到IoT Hub RabbitMQ的uri，username和password等进行连接。示例代码可参考EI-PaaS Data Worker部分。
