# 一、Tableau简介
    Tableau公司将数据运算与美观的图表完美地嫁接在一起，界面上的数据容易操控，
    可以用它将大量数据拖放到数字“画布”上，转眼间就能创建好各种图表。是简单易用却功能强大的数据可视化工具。
    Tableau所能处理的数据可以来自文件和服务器两种形式，文件诸如：CSV文件、Excel文件、access等；
    而服务器则可以连接OData、Google表格以及通过web数据连接器获取各类数据库的数据。
# 二、Tableau连接到文件并可视化
## 1. Tableau连接到文件
### （1）准备一个CSV文件
此处准备了一份皮马印第安人糖尿病数据，数据来源： http://archive.ics.uci.edu/ml/datasets/Pima+Indians+Diabetes
可在网盘中下载：http://pan.baidu.com/s/1eSJ71Eq 密码：e2tf
### （2）打开Tableau
请自行到Tableau官网下载并安装最新版
### （3）打开csv文件
点击左上角星星按钮，选择连接到文本文件
	![](images/Tableau_01.jpg)

###（4）查看数据并准备工作
获得数据后，可在此页面查看。点击“工作表1”即可转到数据可视化工作区。
	![](images/Tableau_02.jpg)
 
## 2. Tableau数据可视化
### （1）数据表字段解释
- CSV文档共有9个字段，分别是：
Pregnant_times						怀孕次数
Plasma_glucose_concentration		血糖浓度
Diastolic_blood_pressure			舒张压
Triceps_skin_fold_thickness			肱三头肌皮肤褶皱厚度
2Hour_serum_insulin				2小时血清胰岛素含量
Body_mass_index					身体质量指数
Diabetes_pedigree_function			糖尿病谱系功能
Age								年龄
Class_variable						标签（0或1）

### （2）Tableau的维度与度量
Tableau中将数据分为“维度”和“度量”，读取csv文件所获得的数据源可能只有维度或者只有度量，可以通过复制到另一板块得到，如下图。
![](images/Tableau_03.jpg) ![](images/Tableau_04.jpg)

维度可以理解为坐标轴，而度量可以理解为坐标轴上的值，例如pima.csv文档中，以age字段为维度时，会在坐标轴上刻画age字段中出现过的age值，
添加age（计数）为度量时，在坐标轴上刻画了每个age对应出现过的次数。如下图。
![](images/Tableau_05.jpg) 

### （3）复杂数据图表的呈现
- a.	选择维度中怀孕次数（pregnant_times）作为列

![](images/Tableau_06.jpg) 

- b.	选择度量中怀孕次数（pregnant_times）作为行，点击行标签中pregnant_times侧的小三角，将度量选为“计数”

![](images/Tableau_07.jpg) 

- c.	拖拽维度中标签（class_variable）到标记栏中的颜色
 

![](images/Tableau_08.jpg) 


现在我们得到了一个以怀孕次数为横坐标，以怀孕次数人数计数为纵坐标，每个条柱分为“患病”（橙色）和“未患病”（蓝色）两种颜色的复杂条形图。

![](images/Tableau_09.jpg) 
 
 
### （4）更复杂的数据可视化手段
Tableau提供了多种更为复杂的数据可视化方法，如工作区右侧的智能显示
![](images/Tableau_10.jpg) ![](images/Tableau_11.jpg) 



  
### （5）专业版Tableau的多种数据源选择
专业版的Tableau提供数百种数据源连接，详见Tableau官网
![](images/Tableau_12.jpg) 

# 三、Tableau的web数据连接器
Tableau对目前不支持的数据源连接，通过web数据连接器来进行数据获取。
## 1.	web数据连接器是什么
使用Web数据连接器SDK，您可以解锁网络上可用的数据世界。 除了使用Tableau中已经提供的数据连接器之外，您还可以创建自己的Web数据连接器（WDC），几乎可以从任何以JSON，XML或HTML格式发布数据的站点读取数据。
## 2.	web数据连接器的原理
首先：通过一个URL获取目标数据源的数据。
第二步：web数据连接器通过URL获取数据后，以JavaScript程序制定相应规则抓取所需数据。
当你需要在Tableau中使用web数据连接器时：
- a.	点击左上角的星星图标
- b.	选择连接到web数据连接器
- c.	在弹出的窗口中输入web数据连接器的URL
这样你就可以得到自己想要的数据了。

![](images/Tableau_13.jpg) 

## 3.	构造你自己的web数据连接器
### （1）	准备一个获取数据的URL
任何数据库都可以实现通过URL获取数据，如下是一个json格式地震数据的URL：https://earthquake.usgs.gov/earthquakes/feed/v1.0/summary/4.5_week.geojson
![](images/Tableau_14.jpg) 

### （2）	web数据连接器SDK和运行模拟器
web数据连接器可以在Tableau官网找到开源的代码，也可以自己开发一个特定场景使用的程序，在这里我们动手开发一个web数据连接器，而开发需要相关SDK和测试环境。
本示例在windows系统下进行，需要工具：git、node和npm
####	下载web数据连接器的SDK
- a)	打开命令行，进入要下载SDK的目录位置
- b)	输入：git clone https://github.com/tableau/webdataconnector.git
- c)	进入webdataconnector目录：cd webdataconnector

![](images/Tableau_15.jpg)  
![](images/Tableau_16.jpg) 

到这里，SDK已经准备完毕。
### 安装运行模拟器
- a)	安装依赖项 npm，输入：npm install --production
![](images/Tableau_17.jpg) 


安装完毕后显示如下：
![](images/Tableau_18.jpg) 

- b)	启动测试web服务器

![](images/Tableau_19.jpg) 

启动成功显示如下：
![](images/Tableau_20.jpg) 

- c)	查看测试web服务器主页

打开浏览器，输入： localhost:8888/Simulator/index.html 可以看到如下页面，说明我们的测试环境安装成功了。

![](images/Tableau_21.jpg) 

 
### （3）	编写你的代码
Web数据连接器的开发，需要：一个HTML文件和一个JavaScript文件。JavaScript响应HTML页面的点击事件，
随后JavaScript程序从我们准备的URL中获取数据，再通过我们制定的规则从URL获取的数据中抓取特定的字段。

- a.	在webdataconnector目录下创建一个开发目录WDCdemo

 ![](images/Tableau_22.jpg) 

- b.	创建一个WDCdemo.html文件和一个WDCdemo.js文件

![](images/Tableau_23.jpg) 

- c.	使用编辑WDCdemo.html文件，拷贝以下代码并保存。注意：代码中蓝色高亮处的字符串指向我们创建的WDCdemo.js文件。

```
<html>

<head>
    <title>USGS Earthquake Feed</title>
    <meta http-equiv="Cache-Control" content="no-store" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css" rel="stylesheet" crossorigin="anonymous">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js" type="text/javascript"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js" crossorigin="anonymous"></script>
    <script src="https://connectors.tableau.com/libs/tableauwdc-2.2.latest.js" type="text/javascript"></script>
    <script src="WDCdemo.js" type="text/javascript"></script>
</head>

<body>
    <div class="container container-table">
        <div class="row vertical-center-row">
            <div class="text-center col-md-4 col-md-offset-4">
                <button type="button" id="submitButton" class="btn btn-success" style="margin: 10px;">Get Earthquake Data!</button>
            </div>
        </div>
    </div>
</body>

</html>

```
#### 解释：
查看上述代码，您会注意到head标签之间的以下内容：
meta标记可防止浏览器缓存页面。
bootstrap.min.css和bootstrap.min.js文件用于简化样式和格式。
jquery.min.js文件是连接器用作辅助库。（如连接器使用jquery获取JSON数据）
tableauwdc-2.2.latest.js文件是WDC API的主库。
WDCdemo.js文件是我们的连接器的JavaScript代码。
在body标签之间，有一个简单的按钮元素，说明用户在获取数据之前如何与连接器进行交互。在稍后的步骤中，您将附加一个事件监听器到JavaScript代码中的按钮
d.	编辑WDCdemo.js文件，拷贝以下代码到文件中。这段代码是JavaScript程序的主体框架，包括获取数据的getData和定制字段的getSchema。
```
(function () {
    var myConnector = tableau.makeConnector();

    myConnector.getSchema = function (schemaCallback) {

    };

    myConnector.getData = function (table, doneCallback) {

    };

    tableau.registerConnector(myConnector);
})();
```
#### 解释：
代码被包装在一个立即被调用的函数表达式中以创建一个局部作用域。
tableau对象未在我们的代码中定义，但在WDC库中。（它被分配到全局范围。）
makeConnector函数是一个构造函数，它为我们的连接器对象预定义了一些方法。
getSchema和getData功能是占位符现在，用于获取数据的表模式和下载数据。
registerConnector函数在初始化之前验证连接器对象。

e.	添加一个事件监听器，响应HTML页面中“Get Earthquake Data!”按钮。将下列代码拷贝到registerConnector函数下面。
```
$(document).ready(function () {
    $("#submitButton").click(function () {
        tableau.connectionName = "USGS Earthquake Feed";
        tableau.submit();
    });
});

```
#### 解释：
	jquery $(document).ready函数在页面加载时运行一些代码。
点击事件监听器被添加到早期创建的按钮元素。该按钮由submitButton ID标识。
tableau.connectionName变量定义它显示在的Tableau的数据源名称。
tableau.submit()函数将连接器对象发送给Tableau进行验证。

f.	定义数据映射的模式，主要是定义了web数据连接器所要展示的数据字段和属性。将下列代码拷贝到getSchema函数中
``` 
    var cols = [
        { id : "mag", alias : "magnitude", dataType : tableau.dataTypeEnum.float },
        { id : "title", alias : "title", dataType : tableau.dataTypeEnum.string },
        { id : "url", alias : "url", dataType : tableau.dataTypeEnum.string },
        { id : "lat", alias : "latitude", columnRole: "dimension", dataType : tableau.dataTypeEnum.float },
        { id : "lon", alias : "longitude",columnRole: "dimension", dataType : tableau.dataTypeEnum.float }
    ];
    var tableInfo = {
        id : "earthquakeFeed",
        alias : "Earthquakes with magnitude greater than 4.5 in the last seven days",
        columns : cols
    };
    schemaCallback([tableInfo]);
```

#### 解释：
	getSchema函数接受由WDC API定义的参数schemaCallback。
cols变量包含一组JavaScript对象，其中每个对象在我们的表中定义了一个列。在此示例中，有大小，标题，纬度和经度的列。请注意，对于每列，您可以指定其他选项。例如，别名定义了可以出现在Tableau中的友好名称，columnRole确定字段是度量还是维度。有关更多选项，请参阅API参考。
tableInfo变量定义单个表的模式，并包含一个JavaScript对象。这里，columns属性的值设置为cols前面定义的数组。

g.	从URL获取数据并选择我们所要的部分。
拷贝以下代码到getData函数中。以下程序将从URL中获取的数据，逐条解析，并将需要的字段添加到数组中返回。
```
$.getJSON("https://earthquake.usgs.gov/earthquakes/feed/v1.0/summary/4.5_week.geojson", function(resp) {
        var feat = resp.features,
            tableData = [];

        // Iterate over the JSON object
        for (var i = 0, len = feat.length; i < len; i++) {
            tableData.push({
                "id": feat[i].id,
                "mag": feat[i].properties.mag,
                "title": feat[i].properties.title,
                "lon": feat[i].geometry.coordinates[0],
                "lat": feat[i].geometry.coordinates[1]
            });
        }

        table.appendRows(tableData);
        doneCallback();
    });
```

#### 解释：
getData函数有两个参数：table和doneCallback。 表参数是由可以附加数据的WDC定义的对象。 doneCallback向Tableau发出信号，表明您已经获取数据。
jquery $ .getJSON功能从USGS地震进给获取地震数据，并将数据存储在响应或响应参数中。 （您可以在浏览器中打开该URL，以查看JSON数据的样子。）
for循环迭代JSON对象中的特征，并将我们想要的数据存储在tableData数组中。
table.appendRows函数将tableData数组作为JavaScript对象附加到表中。

至此，web数据连接器的程序已经准备完毕。另外，Tableau官网中有关于web数据连接器的教程：https://tableau.github.io/webdataconnector/docs/wdc_tutorial

### （4）查看并在Tableau中展示它们
从web测试服务器主页查看web数据连接器得到的数据
- a.	从浏览器打开测试主页：http://localhost:8888/Simulator/index.html
- b.	在connector URL栏中填入：../WDCdemo/WDCdemo.html  这是web数据连接器的路径，根目录是webdataconnector。

![](images/Tableau_24.jpg) 
- c.	点击“Start interactive Phase”，再点击“Get Earthquake Data!”


![](images/Tableau_25.jpg) 


- d.	Table中得到我们设定的表模式

 ![](images/Tableau_26.jpg) 

- e.	点击上图红框所示的“Fetch Table Data”得到数据

 ![](images/Tableau_27.jpg) 

现在，我们开发的web数据连接器已经通过了测试。
## 从Tableau连接web数据连接器并展示

a.	Tableau连接到web数据连接器。注：填入的URL是web数据连接器的URL
![](images/Tableau_28.jpg) 

b.	点击“Get Earthquake Data!”之后，开始查询相关数据
 ![](images/Tableau_29.jpg) 

c.	得到了数据源
 ![](images/Tableau_30.jpg) 

d.	将数据可视化
 ![](images/Tableau_31.jpg) 


