How to Deploy Java Web App to WISE-PaaS
===

### Guide's Building Environment

本教程环境：win10 64bit

### Java Developing Environment

#### Installing Java JDK

- 在Oracle官网上下载适配开发者操作系统的Java JDK，[點此網址進行下載](http://www.oracle.com/technetwork/java/javase/downloads/jdk8-downloads-2133151.html)

![](images/java_web_app_01.jpg)

- 下载完成后进行安装，之后配置JDK环境变量，需要设置JAVA_HOME，CLASSPATH，PATH三个环境变量。
	- JAVA_HOME:JDK的安装路径，如 `C:\Program Files\Java\jdk1.8.0_60`；
	- PATH:系统能够在任何路径下识别java命令，在系统原有的PATH后新增 `%JAVA_HOME%bin;%JAVA_HOME%/jre/bin;` 即可
	- CLASSPATH:类加载路径，只有类在CLASSPATH路径中，java命令才能识别，设为 `.;%JAVA_HOME%/lib/dt.jar;%JAVA_HOME%/lib/tools.jar`
- 配置之后在cmd中运行java，显示结果如下即成功

![](images/java_web_app_02.jpg)

#### Installing Tomcat

- 在Tomcat官网上下载适配开发者操作系统的Tomcat版本，[點此網址進行下載](http://tomcat.apache.org/download-80.cgi)，下载后解压如下图

![](images/java_web_app_03.jpg)

#### Installing IDE for Java

下载JetBrains的IntelliJ IDEA，IntelliJ IDEA是java语言开发的集成环境，[點此網址進行下載](https://www.jetbrains.com/idea/download)

### Install Cloud Foundray CLI Tool

#### Installing CLI Tool

- 进入[以下链接下载](https://docs.cloudfoundry.org/cf-cli/install-go-cli.html)之后，解压到文件夹，运行其中的cf_install.exe。

![](images/python_web_app_10.jpg)

- 点击install后，安装程序自动执行。到这里，CF安装完成。

![](images/python_web_app_11.jpg)

#### Checking CLI Commands

- 登录
	- 打开cmd窗口，输入 `cf login –a api.wise-paas.com.cn`
	- 在email后输入帐号，接着输入密码（注意，密码输入无界面显示）
	- 输入后按回车键，若有以下界面，则证明登录成功。
	
	![](images/python_web_app_12.jpg)

- CF常用命令
	- `cf apps`: 检查该space下所有应用。
	
	![](images/python_web_app_13.jpg)

	- `cf services`: 检查该space下所有服务。
	
	![](images/python_web_app_14.jpg)

	- `cf help` 或是 `cf help -a`: 查看更多CF命令

### Develop your Java Web App

- 创建一个新的project，选择[maven](http://maven.apache.org/)工具来创建webapp项目。maven是一个项目构建工具，多用于java项目。选择如下选项后点击Next。

![](images/java_web_app_04.jpg)

- 填写GroupID和ArtifactID，之后点击Next，填写project location，最后点击finish
	- GroupID: 公司名或组织名，一般由三部分组成，每部分使用”.”隔开，第一部分为项目类型(如商业为com或者非营利性组织为org)，第二部是公司名，第三部分为项目名
	- ArtifactID: 项目名
	
![](images/java_web_app_05.jpg)

- 创建项目后，右下角会弹出maven项目的提示框，点击Enable Auto-Import，之后maven的配置文件pom.xml发生改变时，maven会自动下载所需的依赖包。

![](images/java_web_app_06.jpg)

- 等待maven下载完所需的包后，此时目录结构如下图所示，默认下有index.jsp文件

![](images/java_web_app_07.jpg)

- 接着进行Tomcat的配置，点击上方导航栏的Run-> Edit Configurations

![](images/java_web_app_08.jpg)

- 之后点击左上”+”, Tomcat Server->Local

![](images/java_web_app_09.jpg)

- 之后点击右下角Fix，选择javawebdemo:war exploded后，点击Apply, OK。此时环境已经全部搭建好了。
接着运行demo，点击右上角运行项目。

![](images/java_web_app_10.jpg)

- 运行后浏览器会弹出localhost:8080如图所示，此时运行成功

![](images/java_web_app_11.jpg)

### Deploy your Java Web App to WISE-PaaS using CLI Tool

#### Buildpacks

由于我们上传的项目可能是java也可能是其他语言python，Cloud Foundry需要区别不同的语言并配置相关的运行环境才能运行上传的项目，此时会用到Cloud Foundry上的[Buildpacks](http://docs.cloudfoundry.org/buildpacks/)。Buildpacks为应用程序提供框架和运行时支持。Buildpacks会检查上传的应用程序，以确定哪些依赖关系并下载相关依赖包，这样我们的项目就能运行起来了。

#### Deploying Application

- 使用 `cf login –a api.wise-paas.com.cn` 命令后输入账号密码后登录。

![](images/java_web_app_12.jpg)

- cmd进入要上传的web项目的根目录中，上传项目有两种方式
	- 使用 `cf push APPNAME` 命令上传，此时cf会将该目录下的所有文件打包后上传到WISE-PaaS上，新上传的应用名即刚才指定的APPNAME。
	![](images/java_web_app_12.jpg)
	- 使用manifest.yml文件进行参数配置，可以在manifest.yml中配置上传应用的相关参数，如app命名，占用内存及创建的实例数目等，cf上传项目时能够读取该配置文件进行相关配置。在上传项目根目录中创建manifest.yml文件，编辑如下内容(name表示上传后该app的命名，memory表示该app占用的内存空间大小，instances表示创建该app的实例数)之后在根目录中cmd运行cf push，cf push命令默认情况下会在当前目录查找命名为manifest.yml的文件，并读取其中的参数将项目进行上传并配置。
	
		```yml
		applications:
		- name: javawebservice
		  memory: 512M
		  instance: 1
		```

- 使用 `cf apps` 可以看到我们新上传的项目

![](images/java_web_app_13.jpg)

- 打开浏览器输出javawebservice.wise-paas.com.cn，可以看到项目的运行，恭喜您已經學會如何開發Java web app並上傳至WISE-PaaS!

![](images/java_web_app_14.jpg)



	
