WISE-PaaS 快速指南
====

WISE-PaaS平台為提供 Industrial Edge to Cloud 快速聯結機制，協助客戶迅速開發、佈署、營運設備連網管理、大數據分析預測及可視化等創新雲服務之首選雲平台。
應用服務開發商可以利用WISE-PaaS平台上強大的開發與佈署工具，快速開發專業等級的物聯網應用服務，上線營運與收費。平台具備多租戶功能，及彈性伸縮的功能，可以依據服務的需求，隨時增減服務容量，可以應付秒殺級服務需求，在使用量低時也能有效節省成本。
開發人員可透過專為開發者打造的 Technical Portal 取得相關的技術資訊：


WISE-PaaS 上提供的工具
---

為省去開發者寫程式的麻煩，平台提供 Dashboard 的拖拉工具 [Freedboard](documents/EI-Dashboard/userguide.md)，以及聯網設備處理邏輯的 [Node-RED](documents/Node-RED/userguide.md)。開發商透過圖形介面即可輕鬆完成服務開發。


WISE-PaaS 上提供的服務
---

平台上提供資料管理、設備管理、解決方案、視覺化工具以及資料分析等五類服務。
資料管理包括MongoDB、PostgreSQL、Common Data Service等，主要讓開發商可以將聯網設備的資料送到雲端儲存。
設備管理包括設備管理RMM與Condor DM服務，讓開發商可以對聯網設備進行管理。


如何開發前端服務
---

WISE-PaaS 除了提供開源碼工具 [Freedboard](documents/EI-Dashboard/userguide.md)，以及聯網設備處理邏輯的 [Node-RED](documents/Node-RED/userguide.md) 讓開發者可以方便開發前端 IoT 應用服務外，也提供研華專為管理 IoT 設備開發的 [WebAccess](http://www.advantech.tw/industrial-automation/webaccess) 供開發者選用。


如何取得開發環境進行開發
---

WISE-PaaS 備有[開發包 (DevBox)](https://drive.google.com/open?id=0Bxux5QDsDN7UVk8zN3Nob1hIdGM) 供開發者下載，開發者只要在自己的開發設備如個人電腦開一個[虛擬機](documents/DevBox/userguide.md)，然後[安裝 DevBox](documents/DevBox/installation.md), 就可以開始進行開發與測試。若開發者不習慣用虛擬機開發，也可以依照[說明](documents/LocalDevelopment/installation.md)，在本機端建構開發環境。


如何佈署服務
---

WISE-PaaS 提供 [command line](documents/CloudFoundryCLI/userguide.md) 及 web GUI 兩種佈署方式。目前 web GUI 僅支援 Java 程式開發的服務 ，其他類型的服務需以 command line 方式佈署。


如何管理服務
---

WISE-PaaS 提供[開發者管理介面](documents/ManagementPortal/userguide.md)，方便開發者了解服務應用的執行與使用情形。


如何讓裝置與 WISE-PaaS 進行溝通
---

[EI-Connect](documents/EI-Connect/ei-connect.md) 是 WISE-PaaS 所提供的軟體開發框架，能夠讓裝置與 WISE-PaaS 進行溝通，它提供了眾多兼具直覺易用與高度智慧的整合性界面，可以加快開發速度，增強系統安全性。


如何取得自己的裝置的回報數據
---

首先必須將裝置部署EI-Agent，可參考上一節「如何讓裝置與 WISE-PaaS 進行溝通」，接著使用Commom Data Service所提供之 [RESTful API](apidoc/Common/api.md)，即可以簡單取得裝置自身資訊或是其所回報之資料。


如何得知 Service credential 取得位置與 SSO token 取得方法
---

SSO token可分為兩種：
1. Web based: WISEAccessToken（代表user）可從 cookie 中取得，而 cookie 的名稱即為 WISEAccessToken（因考量安全因素，前端 app 無法取得）。
2. Native based: WISEAppToken（代表app）可從 SSO API 取得，HTTP method 為 POST，在 body 中以 JSON 格式代入 appId 與 userId 即可取得。

Service credential的取得方式有兩種，一種是在 technical portal 登入後，可以取得 WISEAccesToken，此Token會以 cookie 的方式儲存在瀏覽器，可以藉由它瀏覽及操作 WISE-PaaS 上的服務。另一種則是透過呼叫 SSO API 的方式取得 WISEAppToken，將其放至 http method 中的 header 裡，即可使用 WISE-PaaS 服務所提供的 API。

詳細的SSO token取得方法請見[SSO Tutorial](documents/SSO/userguide.md)

如何自己設計 Widget
---

自己設計 Widget 在 WISE-PaaS 平台是非常容易的一件事情，請參考[文件](documents/EI-Dashboard/customizedwidget.md)。


參考範例
---

你的應用程序可能是什麼樣子，它可能如何設計？ 來看看我們提供的[範例程式](https://portal-dashboard.wise-paas.com/FreeBoard.html#sheet=Foodcourt)。

